<Query Kind="Statements">
  <Connection>
    <ID>8c50f33b-f431-47ce-ab08-85212ab1f0a3</ID>
    <Driver Assembly="StreamInsightLinqPad" PublicKeyToken="3d3a4b0768c9178e">StreamInsightLinqPad.StaticDriver</Driver>
    <CustomAssemblyPath>StreamInsightLinqPad.Samples.dll</CustomAssemblyPath>
    <CustomTypeName>StreamInsightLinqPad.Samples.StreamInsightContext</CustomTypeName>
    <DriverData>
      <ContextKind>StreamInsight</ContextKind>
      <RequiredVersion>21.0.0.0</RequiredVersion>
    </DriverData>
  </Connection>
</Query>

// This sample demonstrates the usage of multiple aggregates in the same expression.
Func<double, DateTimeOffset> t = i => new DateTime(2011, 1, 1).AddMinutes(i);

var source = Application.DefineEnumerable(() => new[]
{
    PointEvent.CreateInsert(t(0), new { Id = "A", Value = 12 }),
    PointEvent.CreateInsert(t(10), new { Id = "A", Value = 14 }),
    PointEvent.CreateInsert(t(12), new { Id = "C", Value = 21 }),
    PointEvent.CreateInsert(t(13), new { Id = "B", Value = 24 }),
    PointEvent.CreateInsert(t(14), new { Id = "B", Value = 22 }),
    PointEvent.CreateInsert(t(15), new { Id = "B", Value = 30 }),
    PointEvent.CreateInsert(t(20), new { Id = "C", Value = 12 }),
    PointEvent.CreateInsert(t(30), new { Id = "A", Value = 29 }),
    PointEvent.CreateInsert(t(35), new { Id = "B", Value = 18 }),
}).ToStreamable(AdvanceTimeSettings.StrictlyIncreasingStartTime);

// compute the percentage of "A" events over 10 min windows.
var result = from win in source.TumblingWindow(TimeSpan.FromMinutes(10))
             select (double)win.Sum(e => (e.Id == "A") ? 1 : 0) / (double)win.Count() * 100;
             
result.Dump();