<Query Kind="Program">
  <Connection>
    <ID>ad2274e5-21dc-4e2c-9f3e-e55feb544557</ID>
    <Driver Assembly="StreamInsightLinqPad" PublicKeyToken="3d3a4b0768c9178e">StreamInsightLinqPad.StaticDriver</Driver>
    <CustomAssemblyPath>StreamInsightLinqPad.Samples.dll</CustomAssemblyPath>
    <CustomTypeName>StreamInsightLinqPad.Samples.StreamInsightContext</CustomTypeName>
    <DriverData>
      <ContextKind>StreamInsight</ContextKind>
      <RequiredVersion>21.0.0.0</RequiredVersion>
    </DriverData>
  </Connection>
</Query>

// This sample demonstrates the usage of a user-defined stream operator.
//
// This UDSO splits the string payload of an incoming event into
// multiple substrings, based on the given delimiter, and returns each
// substring as a new event.
void Main()
{
    var source = Application.DefineEnumerable(() => new [] {
        PointEvent.CreateInsert(new DateTime(2011, 1, 1, 1, 0, 0), "Friends;Romans;countrymen") ,
        PointEvent.CreateInsert(new DateTime(2011, 1, 1, 2, 0, 0), "lend;me;your;ears"),
    }).ToStreamable(AdvanceTimeSettings.StrictlyIncreasingStartTime);

    var query = source.Scan(() => new Split(";"));

    query.ToPointEnumerable().Dump();
}
    
[DataContract]
public class Split : Microsoft.ComplexEventProcessing.Extensibility.CepPointStreamOperator<string, string>
{
    [DataMember]
    readonly string _delimiter;

    public Split(string d) // Public ctor used with the Scan LINQ operator.
    {
        _delimiter = d;
    }
    
    public override DateTimeOffset? NextCti { get { return null; } }
    
    public override bool IsEmpty { get { return true; } }

    public override IEnumerable<string> ProcessEvent(PointEvent<string> inputEvent)
    {
        return inputEvent.Payload.Split(new string[] { _delimiter }, StringSplitOptions.RemoveEmptyEntries);
    }
}