<Query Kind="Statements">
  <Connection>
    <ID>1e3830fd-9f17-427d-b3c8-0693c06d6e5c</ID>
    <Driver Assembly="StreamInsightLinqPad" PublicKeyToken="3d3a4b0768c9178e">StreamInsightLinqPad.StaticDriver</Driver>
    <CustomAssemblyPath>StreamInsightLinqPad.Samples.dll</CustomAssemblyPath>
    <CustomTypeName>StreamInsightLinqPad.Samples.HitchhikersGuideContext</CustomTypeName>
    <DriverData>
      <ContextKind>HitchhikersGuide</ContextKind>
      <RequiredVersion>21.0.0.0</RequiredVersion>
    </DriverData>
  </Connection>
</Query>

// Find toll data for a specific tag. Project the license plate number and vehicle
// description.
var query = from t in TollData
            where t.Tag == "567891234"
            select new { t.LicensePlate, t.Make, t.Model, t.Tag, };

// Since this is a historical query, use an enumerable sink. On the output,
// show only insert events, not CTI events.
var sink = from i in query.ToIntervalEnumerable()
           where i.EventKind == EventKind.Insert
           select i;
       
sink.Dump("Results");