<Query Kind="Statements">
  <Connection>
    <ID>1e3830fd-9f17-427d-b3c8-0693c06d6e5c</ID>
    <Driver Assembly="StreamInsightLinqPad" PublicKeyToken="3d3a4b0768c9178e">StreamInsightLinqPad.StaticDriver</Driver>
    <CustomAssemblyPath>StreamInsightLinqPad.Samples.dll</CustomAssemblyPath>
    <CustomTypeName>StreamInsightLinqPad.Samples.HitchhikersGuideContext</CustomTypeName>
    <DriverData>
      <ContextKind>HitchhikersGuide</ContextKind>
      <RequiredVersion>21.0.0.0</RequiredVersion>
    </DriverData>
  </Connection>
</Query>

// Simulate the left stream input from inputStream
var outerJoin_L = from e in TollData
				  select new
				  {
					  LicensePlate = e.LicensePlate,
					  Make = e.Make,
					  Model = e.Model,
				  };

// Simulate the right stream input from inputStream – eliminate all events with Toyota as the vehicle
// These should be the rows in the outer joined result with NULL values for Toll and LicensePlate
var outerJoin_R = from e in TollData
				  where !e.Make.Equals("Toyota")
				  select new
				  {
					  LicensePlate = e.LicensePlate,
					  Toll = e.Toll,
					  TollId = e.TollId
				  };

// Inner join the two simulated input streams
var innerJoin = from left in outerJoin_L
				from right in outerJoin_R
				where left.LicensePlate.Equals(right.LicensePlate)
				select new
				{
					LicensePlate = left.LicensePlate,
					Make = left.Make,
					Model = left.Model,
					Toll = (float?)right.Toll,
					TollId = right.TollId
				};

// Left anti-semijoin the two input simulated streams, and add the Project
var outerJoin_lasj = from left in outerJoin_L.LeftAntiJoin(outerJoin_R, 
                            left => left.LicensePlate, 
                            right => right.LicensePlate)
					 select new
					 {
						 LicensePlate = left.LicensePlate,
						 Make = left.Make,
						 Model = left.Model,
						 Toll = (float?)null,
						 TollId = (string)null
					 };

// Union the two streams to complete a Left Outer Join operation
var queryStream = innerJoin.Union(outerJoin_lasj);

queryStream.ToIntervalEnumerable().Dump();