<Query Kind="Statements">
  <Connection>
    <ID>1e3830fd-9f17-427d-b3c8-0693c06d6e5c</ID>
    <Driver Assembly="StreamInsightLinqPad" PublicKeyToken="3d3a4b0768c9178e">StreamInsightLinqPad.StaticDriver</Driver>
    <CustomAssemblyPath>StreamInsightLinqPad.Samples.dll</CustomAssemblyPath>
    <CustomTypeName>StreamInsightLinqPad.Samples.HitchhikersGuideContext</CustomTypeName>
    <DriverData>
      <ContextKind>HitchhikersGuide</ContextKind>
      <RequiredVersion>21.0.0.0</RequiredVersion>
    </DriverData>
  </Connection>
</Query>

// Flag all vehicles that pass a toll booth without a tag.

// Simulate the reference stream from tStream itself - convert it to a point
// event stream
var referenceStream = TollData.ToPointEventStream();

// Simulate the tag violations in the observed stream by filtering out specific
// vehicles. Let us filter out all the events in the dataset TollInput.txt with
// a Tag length of 0 (this is the last element in each line in TollInput.txt).
// In a real scenario, these events will not exist at all – this simulation is only
// because we are reusing the same input stream for this example.
// The events that were filtered out should be the ones that show up in the output of tQ7
var observedStream = from e in TollData.ToPointEventStream()
                     where string.IsNullOrEmpty(e.Tag)
                     select e;

// Report tag violations
var query = referenceStream.LeftAntiJoin(observedStream, (l, r) => true);

query.Dump();