<Query Kind="Statements">
  <Connection>
    <ID>1e3830fd-9f17-427d-b3c8-0693c06d6e5c</ID>
    <Driver Assembly="StreamInsightLinqPad" PublicKeyToken="3d3a4b0768c9178e">StreamInsightLinqPad.StaticDriver</Driver>
    <CustomAssemblyPath>StreamInsightLinqPad.Samples.dll</CustomAssemblyPath>
    <CustomTypeName>StreamInsightLinqPad.Samples.HitchhikersGuideContext</CustomTypeName>
    <DriverData>
      <ContextKind>HitchhikersGuide</ContextKind>
      <RequiredVersion>21.0.0.0</RequiredVersion>
    </DriverData>
  </Connection>
</Query>

// Report the top 2 toll amounts from the results of example 04 over a 3-minute tumbling window
var slidingAggregate = from t in TollData.AlterEventDuration(e => TimeSpan.FromMinutes(3))
group t by t.TollId into g
from win in g.SnapshotWindow()
select new
{
    TollId = g.Key,
    TotalToll = win.Sum(t => t.Toll),
    Count = win.Count()
};

var query = from win in slidingAggregate.TumblingWindow(TimeSpan.FromMinutes(3))
            from r in (from e in win
                       orderby e.TotalToll descending
                       select e).Take(2, e => new
                       {
                           e.Rank,
                           e.Payload.TotalToll,
                           e.Payload.TollId,
                           e.Payload.Count
                       })
            select r;

query.Dump();