<Query Kind="Statements">
  <Connection>
    <ID>aece76e1-78ad-477f-aa7a-328376fd9645</ID>
    <Driver Assembly="StreamInsightLinqPad" PublicKeyToken="3d3a4b0768c9178e">StreamInsightLinqPad.StaticDriver</Driver>
    <CustomAssemblyPath>StreamInsightLinqPad.Samples.dll</CustomAssemblyPath>
    <CustomTypeName>StreamInsightLinqPad.Samples.PerformanceCounterContext</CustomTypeName>
    <DriverData>
      <ContextKind>PerformanceCounter</ContextKind>
      <RequiredVersion>21.0.0.0</RequiredVersion>
    </DriverData>
  </Connection>
</Query>

// Computing processor utilization per core

// Construct a stream per core using LINQ to Objects and LINQ to StreamInsight.
var streams = from id in Enumerable.Range(0, Environment.ProcessorCount)
              select from s in CreateStream("Processor", "% Processor Time", id.ToString())
                     select new { ProcessorID = id, Value = s.Value };

// Use LINQ to Objects Aggregate to union streams for all cores.
var input = streams.Aggregate(QStreamable.Union);

// Measure processor utilization per core over 10-second windows that advance
// in 1-second increments.
var query = from s in input
            group s by s.ProcessorID into g
            from win in g.HoppingWindow(TimeSpan.FromSeconds(10), TimeSpan.FromSeconds(1))
            select new { Avg = win.Avg(s => s.Value), ProcessorID = g.Key };

query.Dump();