<Query Kind="Statements">
  <Connection>
    <ID>ad2274e5-21dc-4e2c-9f3e-e55feb544557</ID>
    <Driver Assembly="StreamInsightLinqPad" PublicKeyToken="3d3a4b0768c9178e">StreamInsightLinqPad.StaticDriver</Driver>
    <CustomAssemblyPath>StreamInsightLinqPad.Samples.dll</CustomAssemblyPath>
    <CustomTypeName>StreamInsightLinqPad.Samples.StreamInsightContext</CustomTypeName>
    <DriverData>
      <ContextKind>StreamInsight</ContextKind>
      <RequiredVersion>21.0.0.0</RequiredVersion>
    </DriverData>
  </Connection>
</Query>

// Illustrating LINQPad output support for StreamInsight queries.

// Synthesize some input data
var random = new Random();

var baseTime = DateTime.UtcNow;

var source = from i in Application.DefineEnumerable(() => Enumerable.Range(0, 10))
             select new { Time = baseTime.AddSeconds(i), Value = random.NextDouble() };
       
// Simple filter query
var query = from e in source.ToPointStreamable(e => PointEvent.CreateInsert(e.Time, e), AdvanceTimeSettings.StrictlyIncreasingStartTime)
            where e.Value > 0.5
            select e;
      
// By default, CepStream is diplayed as a push-based (IObservable) point event sequence.
query.Dump("Default");

// You can also display results as pull-based sequences (IEnumerable)
query.ToEnumerable().Dump("Enumerable");
query.ToPointEnumerable().Dump("Point Enumerable");
query.ToIntervalEnumerable().Dump("Interval Enumerable");
query.ToEdgeEnumerable().Dump("Edge Enumerable");

// Consider customizing output display
var sink1 = from p in query.ToPointEnumerable()
            where p.EventKind == EventKind.Insert
            select new { p.Payload.Value, p.StartTime };
      
sink1.Dump("Sink1");

var sink2 = from e in query.ToEdgeObservable()
            where e.EventKind == EventKind.Insert && e.EdgeType == EdgeType.End
            select new { e.Payload.Value, e.StartTime, e.EndTime };
      
sink2.Dump("Sink2");